/*--------------------------------------------------
  rsdpa_include.h
--------------------------------------------------*/

#ifndef __rsdpa_include_h__
#define __rsdpa_include_h__

#include <rsdpa_right.h>

// if you use ATLAS, you need to set 0
// otherwise (for example, BLAS in clapack.tgz), set 1
//           and edit Makefile to change LAPACK_LIB

#define NON_ATLAS_SDPA 0

#include <iostream>
#include <fstream>
#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <cstring>

extern "C" {
#include <f2c.h>
#if NON_ATLAS_SDPA
#include <blaswrap.h>
#endif
#include <fblaswr.h>
#include <cblas.h>
#include <clapack.h>
};

using namespace std;

#define _SUCCESS true
#define FAILURE false

#include <rsdpa_tool.h>

// for parallel computing
#include <rsdpa_mpist.h>

#endif // __rsdpa_include_h__
