/*--------------------------------------------------
  rsdpa_tool.h
--------------------------------------------------*/

#ifndef __rsdpa_tool_h__
#define __rsdpa_tool_h__

#include <rsdpa_right.h>

#include <iostream>
#include <sys/time.h>
#include <cstring>
#include <string>

#if 1
#define rMessage(message) \
cout << message \
<< " :: iam = "<< rMpiSt::iam \
<< " :: line " << __LINE__ \
<< " in " << __FILE__ << endl
#else
#define rMessage(message)
#endif

#define rError(message) \
cout << message \
<< " :: iam = "<< rMpiSt::iam \
<< " :: line " << __LINE__ \
<< " in " << __FILE__ << endl; \
rMpiSt::finalize(); \
exit(false);

#if 0
#define rNewCheck() rMessage("new invoked");
#else
#define rNewCheck() ;
#endif

#define REVERSE_PRIMAL_DUAL 1


// These are constant. Do NOT change
extern int IZERO   ; // =  0;
extern int IONE    ; // =  1;
extern int IMONE   ; // = -1;
extern double DZERO; // =  0.0;
extern double DONE ; // =  1.0;
extern double DMONE; // = -1.0;

class rTime
{
public:
  static double rGetUserTime();
  static void rSetTimeVal(struct timeval & targetVal);
  static double rGetRealTime(const struct timeval & start,
			     const struct timeval & end);
};

#if 0 // count time with process time
#define rTimeStart(START__) \
   static double START__; START__ = rTime::rGetUserTime()
#define rTimeEnd(END__) \
   static double END__;   END__ = rTime::rGetUserTime()
#define rTimeCal(START__,END__) (END__ - START__)
#else // count time with real time
#define rTimeStart(START__) \
   static struct timeval START__; rTime::rSetTimeVal(START__)
#define rTimeEnd(END__) \
   static struct timeval END__; rTime::rSetTimeVal(END__)
#define rTimeCal(START__,END__) rTime::rGetRealTime(START__,END__)
#endif

#endif // __rsdpa_tool_h__
